unit KbdTable;

interface

uses Windows;

const
  KEY_MAKE  = $00;
  KEY_BREAK = $01;

  KBDBASE   = $0;
  KBDSHIFT  = $1;
  KBDCTRL   = $2;
  KBDALT    = $4;

  WCH_NONE= $F000;
  WCH_DEAD= $F001;
  WCH_LGTR= $F002;

  CAPLOK     = $01;
  SGCAPS     = $02;
  CAPLOKALTGR= $04;

type
  VSC_LPWSTR = record
    vsc : BYTE;
    pwsz : PWCHAR;
   end;
  PVSC_LPWSTR = ^ VSC_LPWSTR;

  VK_TO_WCHARS1 = record
    VirtualKey: BYTE;
    Attributes: BYTE;
    wch:array[0..0] of WCHAR;
   end;
  PVK_TO_WCHARS1 = ^ VK_TO_WCHARS1;

  VK_TO_WCHAR_TABLE = record
    pVkToWchars: PVK_TO_WCHARS1;
    nModifications: BYTE;
    cbSize: BYTE;
   end;
  PVK_TO_WCHAR_TABLE = ^ VK_TO_WCHAR_TABLE;

  VK_TO_BIT = record
    Vk: BYTE;
    ModBits: BYTE;
   end;
  PVK_TO_BIT = ^ VK_TO_BIT;
  
  MODIFIERS = record
    pVkToBit: PVK_TO_BIT ;     // Virtual Keys -> Mod bits
    wMaxModBits: WORD;  // max Modification bit combination value
    ModNumber:array[0..0] of BYTE;  // Mod bits -> Modification Number
   end; 
  PMODIFIERS = ^ MODIFIERS;

  KBDTABLES = record
    pCharModifiers :PMODIFIERS;
    pVkToWcharTable: PVK_TO_WCHAR_TABLE;
    pDeadKey : Pointer;
    pKeyNames: PVSC_LPWSTR;
    pKeyNamesExt: PVSC_LPWSTR;
    pKeyNamesDead: pointer;
    pusVSCtoVK: PWord;
    bMaxVSCtoVK: BYTE;
    pVSCtoVK_E0: Pointer;
    pVSCtoVK_E1: Pointer;
    fLocaleFlags: DWORD;
    nLgMax: BYTE;
    cbLgEntry: BYTE;
    pLigature: Pointer;
    dwType: DWORD; 
    dwSubType: DWORD;
   end;
  PKBDTABLES = ^ KBDTABLES;

  TGetKbdLayerDescriptorFunc = function():PKBDTABLES; stdcall;

function GetKeyNameW(pKbdTable:PKBDTABLES; KeyScanCode:word):PWChar;
function GetVirtualCodeFromScanCode(pKbdTable:PKBDTABLES; KeyScanCode:Word):Word;
//function GetMODBitFromVK(pKbdTable:PKBDTABLES; VirtualCode:Word):BYTE;
//function GetModNumberFromModBits(pKbdTable:PKBDTABLES; ModBits :BYTE):integer;
//function GetWCHAR(pKbdTable:PKBDTABLES; ModNum:BYTE; VirtualCode: Word):WCHAR;

implementation
{
code not work! may be it work, but not tested...

function GetWCHAR(pKbdTable:PKBDTABLES; ModNum:BYTE; VirtualCode: Word):WCHAR;
var
  pCurrTable: PVK_TO_WCHAR_TABLE;
  pCurrWCHAR: PVK_TO_WCHARS1;
begin
  Result:=WCHAR(VirtualCode);
  Exit;
  pCurrTable := pKbdTable^.pVkToWcharTable;
  while pCurrTable^.pVkToWchars<>nil do
   begin
    if pCurrTable^.nModifications>=ModNum then
     begin
      pCurrWCHAR:=pCurrTable^.pVkToWchars;
      while pCurrWCHAR^.VirtualKey<>0 do
       begin
        if (pCurrWCHAR^.VirtualKey=VirtualCode) then
         begin
          Result:=pCurrWCHAR^.wch[ModNum];
          exit;
         end;
        pCurrWCHAR := PVK_TO_WCHARS1(DWORD(pCurrWCHAR)+sizeof(VK_TO_WCHARS1)+pCurrTable^.nModifications-1);
       end;
     end;
    pCurrTable := PVK_TO_WCHAR_TABLE(DWORD(pCurrTable)+sizeof(VK_TO_WCHAR_TABLE));
   end;
end;

function GetModNumberFromModBits(pKbdTable:PKBDTABLES; ModBits :BYTE):integer;
begin
  Result:=0; 
  if pKbdTable^.pCharModifiers.wMaxModBits<=ModBits then
   Result:= pKbdTable^.pCharModifiers.ModNumber[ModBits];
end;

function GetMODBitFromVK(pKbdTable:PKBDTABLES; VirtualCode:Word):BYTE;
var
  pCurrItem: PVK_TO_BIT;
begin
  Result:=0;
  pCurrItem := pKbdTable^.pCharModifiers.pVkToBit;
  while pCurrItem^.Vk<>0 do
   begin
    if pCurrItem^.Vk = VirtualCode then
     begin
      Result:= pCurrItem^.ModBits;
      exit;
     end;
    pCurrItem := PVK_TO_BIT(DWORD(pCurrItem)+sizeof(VK_TO_BIT));
   end;
end;
}

function GetKeyNameW(pKbdTable:PKBDTABLES; KeyScanCode:word):PWChar;
var
  pCurrItem:PVSC_LPWSTR;
begin
  Result:=nil; 
  pCurrItem := pKbdTable^.pKeyNames;
  while pCurrItem^.vsc<>0 do
   begin
    if pCurrItem^.vsc = KeyScanCode then
     begin
      Result:= pCurrItem^.pwsz;
      exit;
     end;
    pCurrItem := PVSC_LPWSTR(DWORD(pCurrItem)+sizeof(VSC_LPWSTR));
   end;
   
  pCurrItem := pKbdTable^.pKeyNamesExt;
  while pCurrItem^.vsc<>0 do
   begin
    if pCurrItem^.vsc = KeyScanCode then
     begin
      Result:= pCurrItem^.pwsz;
      exit;
     end;
    pCurrItem := PVSC_LPWSTR(DWORD(pCurrItem)+sizeof(VSC_LPWSTR));
   end;
end;

function GetVirtualCodeFromScanCode(pKbdTable:PKBDTABLES; KeyScanCode:Word):Word;
begin
  Result:= PWord(DWORD(pKbdTable^.pusVSCtoVK)+KeyScanCode*sizeof(Word))^;
end;

end.
 